# Package org.apache.tools.ant.taskdefs.optional.testing

- Class Summary
  Class | Description
  --- | ---
  BlockFor |
  Funtest | Task to provide functional testing under Ant, with a fairly complex workflow of: Conditional execution Application to start A probe to "waitfor" before running tests A tests sequence A reporting sequence that runs after the tests have finished A "teardown" clause that runs after the rest. Automated termination of the program it executes, if a timeout is not met Checking of a failure property and automatic raising of a fault (with the text in failureText) if test shutdown and reporting succeeded The task is designed to be framework neutral; it will work with JUnit, TestNG and other test frameworks That can be executed from Ant.

- Exception Summary
  Exception | Description
  --- | ---
  BuildTimeoutException | This exception is used to indicate timeouts.